Index: /trunk/LMDZ.MARS/libf/phymars/testphys1d.F
===================================================================
--- /trunk/LMDZ.MARS/libf/phymars/testphys1d.F	(revision 1035)
+++ /trunk/LMDZ.MARS/libf/phymars/testphys1d.F	(revision 1036)
@@ -2,5 +2,6 @@
       PROGRAM testphys1d
 ! to use  'getin'
-      USE ioipsl_getincom 
+      USE ioipsl_getincom, only: getin
+      use infotrac, only: nqtot, tnom
       IMPLICIT NONE
 
@@ -42,5 +43,5 @@
 #include "comg1d.h"
 #include "logic.h"
-#include "advtrac.h"
+!#include "advtrac.h"
 
 c --------------------------------------------------------------
@@ -64,6 +65,6 @@
       REAL gru,grv   ! prescribed "geostrophic" background wind
       REAL temp(nlayermx)   ! temperature at the middle of the layers
-      REAL q(nlayermx,nqmx) ! tracer mixing ratio (e.g. kg/kg)
-      REAL qsurf(nqmx)      ! tracer surface budget (e.g. kg.m-2)
+      REAL,ALLOCATABLE :: q(:,:) ! tracer mixing ratio (e.g. kg/kg)
+      REAL,ALLOCATABLE :: qsurf(:) ! tracer surface budget (e.g. kg.m-2)
       REAL tsoil(nsoilmx)   ! subsurface soik temperature (K)
       REAL co2ice           ! co2ice layer (kg.m-2)
@@ -76,6 +77,6 @@
       REAL dudyn(nlayermx),dvdyn(nlayermx),dtempdyn(nlayermx)
       REAL dpsurf    
-      REAL dq(nlayermx,nqmx)
-      REAL dqdyn(nlayermx,nqmx)
+      REAL,ALLOCATABLE :: dq(:,:)
+      REAL,ALLOCATABLE :: dqdyn(:,:)
 
 c   Various intermediate variables
@@ -84,5 +85,6 @@
       REAL phi(nlayermx),h(nlayermx),s(nlayermx)
       REAL pks, ptif, w(nlayermx)
-      REAL qtotinit, mqtot(nqmx),qtot
+      REAL qtotinit,qtot
+      real,allocatable :: mqtot(:)
       INTEGER ierr, aslun
       REAL tmp1(0:nlayermx),tmp2(0:nlayermx)
@@ -169,5 +171,5 @@
 
 ! while we're at it, check if there is a 'traceur.def' file
-! and preocess it, if necessary. Otherwise initialize tracer names
+! and process it.
       if (tracer) then
       ! load tracer names from file 'traceur.def'
@@ -183,19 +185,21 @@
           ! read number of tracers:
           read(90,*,iostat=ierr) nq
+          nqtot=nq ! set value of nqtot (in infotrac module) as nq
           if (ierr.ne.0) then
             write(*,*) "testphys1d: error reading number of tracers"
             write(*,*) "   (first line of traceur.def) "
             stop
-          else
-            ! check that the number of tracers is indeed nqmx
-            if (nq.ne.nqmx) then
-              write(*,*) "testphys1d: error, wrong number of tracers:"
-              write(*,*) "nq=",nq," whereas nqmx=",nqmx
-              stop
-            endif
           endif
         endif
+        ! allocate arrays:
+        allocate(tnom(nq))
+        allocate(q(nlayermx,nq))
+        allocate(qsurf(nq))
+        allocate(dq(nlayermx,nq))
+        allocate(dqdyn(nlayermx,nq))
+        allocate(mqtot(nq))
+        
         ! read tracer names from file traceur.def
-        do iq=1,nqmx
+        do iq=1,nq
           read(90,*,iostat=ierr) tnom(iq)
           if (ierr.ne.0) then
@@ -212,5 +216,5 @@
         ! "smarter" initialization of some tracers
         ! (get values from "profile_*" files, if these are available)
-        do iq=1,nqmx
+        do iq=1,nq
           txt=""
           write(txt,"(a)") tnom(iq)
@@ -346,9 +350,16 @@
             close(91)
           endif ! of if (txt.eq."ccn_number")
-        enddo ! of do iq=1,nqmx
+        enddo ! of do iq=1,nq
 
       else
-      ! we still need to set (dummy) tracer names for physdem1
-        nq=nqmx
+      ! we still need to set (dummy) tracer number and names for physdem1
+        nq=1
+        ! allocate arrays:
+        allocate(tnom(nq))
+        allocate(q(nlayermx,nq))
+        allocate(qsurf(nq))
+        allocate(dq(nlayermx,nq))
+        allocate(dqdyn(nlayermx,nq))
+        allocate(mqtot(nq))
         do iq=1,nq
           write(str7,'(a1,i2.2)')'q',iq
@@ -496,5 +507,5 @@
 
 !Mars possible matter with dtphys in input and include!!!
-      CALL inifis(1,llm,day0,daysec,dtphys,
+      CALL inifis(1,llm,nq,day0,daysec,dtphys,
      .            lati,long,area,rad,g,r,cpp)
 
@@ -612,5 +623,5 @@
          ! thermo=0: initialize over all atmospheric layers
          thermo=0
-         call inichim_newstart(q,psurf,sig,nqmx,lati,long,area,
+         call inichim_newstart(q,psurf,sig,nq,lati,long,area,
      $   thermo,qsurf)
       endif
@@ -641,8 +652,8 @@
 c  It is needed to transfert physics variables to "physiq"...
 
-      call physdem0("startfi.nc",long,lati,nsoilmx,nqmx,
+      call physdem0("startfi.nc",long,lati,nsoilmx,nq,
      .              dtphys,float(day0),time,area,
      .              albedodat,inertiedat,zmea,zstd,zsig,zgam,zthe)
-      call physdem1("startfi.nc",nsoilmx,nqmx,
+      call physdem1("startfi.nc",nsoilmx,nq,
      .              dtphys,time,
      .              tsurf,tsoil,co2ice,emis,q2,qsurf)
@@ -688,5 +699,5 @@
 c       --------------------
 !      write(*,*) "testphys1d avant q", q(1,:)
-      CALL physiq (1,llm,nqmx,
+      CALL physiq (1,llm,nq,
      ,     firstcall,lastcall,
      ,     day,time,dtphys,
@@ -749,5 +760,5 @@
 
 !       increment tracers
-        DO iq = 1, nqmx
+        DO iq = 1, nq
           DO ilayer=1,nlayer
              q(ilayer,iq)=q(ilayer,iq)+dtphys*dq(ilayer,iq)
Index: /trunk/LMDZ.MARS/libf/phymars/tracer_mod.F90
===================================================================
--- /trunk/LMDZ.MARS/libf/phymars/tracer_mod.F90	(revision 1036)
+++ /trunk/LMDZ.MARS/libf/phymars/tracer_mod.F90	(revision 1036)
@@ -0,0 +1,80 @@
+module tracer_mod
+
+ implicit none
+ 
+      ! number of tracers:
+      integer,save :: nqmx ! initialized in inifis
+      
+      character*20,allocatable,save ::  noms(:)  ! name of the tracer
+      real,allocatable,save :: mmol(:)           ! mole mass of tracer (g/mol-1) 
+      real,allocatable,save :: radius(:)   ! dust and ice particle radius (m)
+      real,allocatable,save :: rho_q(:)    ! tracer densities (kg.m-3)
+      real,allocatable,save :: alpha_lift(:) ! saltation vertical flux/horiz flux ratio (m-1)
+      real,allocatable,save :: alpha_devil(:) ! lifting coeeficient by dust devil
+
+      real,save :: varian      ! Characteristic variance of log-normal distribution
+      real,save :: r3n_q     ! used to compute r0 from number and mass mixing ratio
+      real,save :: rho_dust     ! Mars dust density (kg.m-3)
+      real,save :: rho_ice     ! Water ice density (kg.m-3)
+      real,save :: nuice_ref   ! Effective variance of the water ice dist.
+      real,save :: nuice_sed   ! Sedimentation effective variance of the water ice dist.
+      real,save :: ref_r0        ! for computing reff=ref_r0*r0 (in log.n. distribution)
+      
+      real,save :: ccn_factor  ! ratio of nuclei for water ice particles
+
+      real,allocatable,save :: dryness(:)!"Dryness coefficient" for grnd water ice sublimation
+      
+! tracer indexes: these are initialized in initracer and should be 0 if the
+!                 corresponding tracer does not exist
+      ! dust
+      integer,allocatable,save :: igcm_dustbin(:) ! for dustbin 'dust' tracers
+      ! dust, special doubleq case
+      integer,save :: igcm_dust_mass   ! dust mass mixing ratio
+                                  !   (for transported dust)
+      integer,save :: igcm_dust_number ! dust number mixing ratio
+                                  !   (transported dust)
+      integer,save :: igcm_ccn_mass   ! CCN mass mixing ratio
+      integer,save :: igcm_ccn_number ! CCN number mixing ratio
+      integer,save :: igcm_dust_submicron ! submicron dust mixing ratio
+                                     !   (transported dust)
+      ! water
+      integer,save :: igcm_h2o_vap ! water vapour
+      integer,save :: igcm_h2o_ice ! water ice
+      ! chemistry:
+      integer,save :: igcm_co2
+      integer,save :: igcm_co
+      integer,save :: igcm_o
+      integer,save :: igcm_o1d
+      integer,save :: igcm_o2
+      integer,save :: igcm_o3
+      integer,save :: igcm_h
+      integer,save :: igcm_h2
+      integer,save :: igcm_oh
+      integer,save :: igcm_ho2
+      integer,save :: igcm_h2o2
+      integer,save :: igcm_n2
+      integer,save :: igcm_ar
+      integer,save :: igcm_n
+      integer,save :: igcm_no
+      integer,save :: igcm_no2
+      integer,save :: igcm_n2d
+      integer,save :: igcm_ch4
+      ! Ions
+      integer,save :: igcm_co2plus
+      integer,save :: igcm_oplus
+      integer,save :: igcm_o2plus
+      integer,save :: igcm_coplus
+      integer,save :: igcm_cplus
+      integer,save :: igcm_nplus
+      integer,save :: igcm_noplus
+      integer,save :: igcm_n2plus 
+      integer,save :: igcm_hplus
+      integer,save :: igcm_hco2plus
+      integer,save :: igcm_elec
+      ! other tracers
+      integer,save :: igcm_ar_n2 ! for simulations using co2 +neutral gas
+
+
+!-----------------------------------------------------------------------
+
+end module tracer_mod
Index: /trunk/LMDZ.MARS/libf/phymars/updaterad.F90
===================================================================
--- /trunk/LMDZ.MARS/libf/phymars/updaterad.F90	(revision 1035)
+++ /trunk/LMDZ.MARS/libf/phymars/updaterad.F90	(revision 1036)
@@ -62,10 +62,11 @@
 ! Update ice radius if microphys == true 
 subroutine updaterice_micro(qice,qccn,nccn,coeff,rice,rhocloud)
-implicit none
-
-#include "dimensions.h"
-#include "dimphys.h"
-#include "comcstfi.h"
-#include "tracer.h"
+use tracer_mod, only: rho_dust, rho_ice
+implicit none
+
+#include "dimensions.h"
+#include "dimphys.h"
+#include "comcstfi.h"
+!#include "tracer.h"
 
 real, intent(in)  :: qice,qccn,nccn
@@ -118,10 +119,11 @@
 ! Update ice radius from a typical profile if microphys == false
 subroutine updaterice_typ(qice,tau,pzlay,rice)
-implicit none
-
-#include "dimensions.h"
-#include "dimphys.h"
-#include "comcstfi.h"
-#include "tracer.h"
+use tracer_mod, only: rho_ice
+implicit none
+
+#include "dimensions.h"
+#include "dimphys.h"
+#include "comcstfi.h"
+!#include "tracer.h"
 
 real, intent(in)  :: qice
@@ -175,10 +177,11 @@
 ! To be used with doubleq == true. otherwise, rdust is constant !!!
 subroutine updaterdust(qdust,ndust,rdust,tauscaling)
-implicit none
-
-#include "dimensions.h"
-#include "dimphys.h"
-#include "comcstfi.h"
-#include "tracer.h"
+use tracer_mod, only: r3n_q
+implicit none
+
+#include "dimensions.h"
+#include "dimphys.h"
+#include "comcstfi.h"
+!#include "tracer.h"
 
 real, intent(in) :: qdust,ndust ! needed if doubleq
@@ -230,10 +233,11 @@
 ! geometric mean radius = mass mean radius x exp(-1.5 sigma0^2)
 subroutine updaterccn(qccn,nccn,rccn,tauscaling)
-implicit none
-
-#include "dimensions.h"
-#include "dimphys.h"
-#include "comcstfi.h"
-#include "tracer.h"
+use tracer_mod, only: rho_dust
+implicit none
+
+#include "dimensions.h"
+#include "dimphys.h"
+#include "comcstfi.h"
+!#include "tracer.h"
 
 real, intent(in) :: qccn,nccn ! needed if doubleq
Index: /trunk/LMDZ.MARS/libf/phymars/updatereffrad.F
===================================================================
--- /trunk/LMDZ.MARS/libf/phymars/updatereffrad.F	(revision 1035)
+++ /trunk/LMDZ.MARS/libf/phymars/updatereffrad.F	(revision 1036)
@@ -4,4 +4,8 @@
      &                pq,tauscaling,tau,pplay)
        USE updaterad
+       use tracer_mod, only: nqmx, igcm_dust_mass, igcm_dust_number,
+     &                       igcm_h2o_ice, igcm_ccn_mass, radius,
+     &                       igcm_ccn_number, nuice_ref, varian,
+     &                       ref_r0, igcm_dust_submicron
        IMPLICIT NONE
 c=======================================================================
@@ -31,5 +35,5 @@
 #include "callkeys.h"
 #include "dimradmars.h"
-#include "tracer.h"
+!#include "tracer.h"
 #include "aerkind.h"
 #include "yomaer.h"
Index: /trunk/LMDZ.MARS/libf/phymars/vdif_kc.F
===================================================================
--- /trunk/LMDZ.MARS/libf/phymars/vdif_kc.F	(revision 1035)
+++ /trunk/LMDZ.MARS/libf/phymars/vdif_kc.F	(revision 1036)
@@ -1,8 +1,10 @@
       SUBROUTINE vdif_kc(dt,g,zlev,zlay,u,v,teta,cd,q2,km,kn,zq)
+
+      use tracer_mod, only: nqmx, noms
       IMPLICIT NONE
 c.......................................................................
 #include "dimensions.h"
 #include "dimphys.h"
-#include "tracer.h"
+!#include "tracer.h"
 #include "callkeys.h"
 c.......................................................................
Index: /trunk/LMDZ.MARS/libf/phymars/vdifc.F
===================================================================
--- /trunk/LMDZ.MARS/libf/phymars/vdifc.F	(revision 1035)
+++ /trunk/LMDZ.MARS/libf/phymars/vdifc.F	(revision 1036)
@@ -11,4 +11,7 @@
 #endif
      &                )
+      use tracer_mod, only: noms, igcm_dust_mass, igcm_dust_number,
+     &                      igcm_dust_submicron, igcm_h2o_vap,
+     &                      igcm_h2o_ice, dryness, alpha_lift, nqmx
       IMPLICIT NONE
 
@@ -39,5 +42,5 @@
 #include "surfdat.h"
 #include "comgeomfi.h"
-#include "tracer.h"
+!#include "tracer.h"
 #include "microphys.h"
 
@@ -46,32 +49,36 @@
 c   ----------
 
-      INTEGER ngrid,nlay
-      REAL ptimestep
-      REAL pplay(ngrid,nlay),pplev(ngrid,nlay+1)
-      REAL pzlay(ngrid,nlay),pzlev(ngrid,nlay+1)
-      REAL pu(ngrid,nlay),pv(ngrid,nlay),ph(ngrid,nlay),pt(ngrid,nlay)
-      REAL ptsrf(ngrid),pemis(ngrid)
-      REAL pdufi(ngrid,nlay),pdvfi(ngrid,nlay),pdhfi(ngrid,nlay)
-      REAL pfluxsrf(ngrid)
-      REAL pdudif(ngrid,nlay),pdvdif(ngrid,nlay),pdhdif(ngrid,nlay)
-      REAL pdtsrf(ngrid),pcapcal(ngrid)
+      INTEGER,INTENT(IN) :: ngrid,nlay
+      REAL,INTENT(IN) :: ptimestep
+      REAL,INTENT(IN) :: pplay(ngrid,nlay),pplev(ngrid,nlay+1)
+      REAL,INTENT(IN) :: pzlay(ngrid,nlay),pzlev(ngrid,nlay+1)
+      REAL,INTENT(IN) :: pu(ngrid,nlay),pv(ngrid,nlay)
+      REAL,INTENT(IN) :: ph(ngrid,nlay)
+      REAL :: pt(ngrid,nlay)
+      REAL,INTENT(IN) :: ptsrf(ngrid),pemis(ngrid)
+      REAL,INTENT(IN) :: pdufi(ngrid,nlay),pdvfi(ngrid,nlay)
+      REAL,INTENT(IN) :: pdhfi(ngrid,nlay)
+      REAL,INTENT(IN) :: pfluxsrf(ngrid)
+      REAL,INTENT(OUT) :: pdudif(ngrid,nlay),pdvdif(ngrid,nlay)
+      REAL,INTENT(OUT) :: pdtsrf(ngrid),pdhdif(ngrid,nlay)
+      REAL,INTENT(IN) ::pcapcal(ngrid)
       REAL pq2(ngrid,nlay+1)
 
 c    Argument added for condensation:
-      REAL co2ice (ngrid), ppopsk(ngrid,nlay)
-      logical lecrit
-
-      REAL pz0(ngridmx) ! surface roughness length (m)
+      REAL,INTENT(IN) :: co2ice (ngrid), ppopsk(ngrid,nlay)
+      logical,INTENT(IN) :: lecrit
+
+      REAL,INTENT(IN) :: pz0(ngrid) ! surface roughness length (m)
 
 c    Argument added to account for subgrid gustiness :
 
-      REAL wstar(ngridmx), hfmax(ngridmx), zi(ngridmx)
+      REAL wstar(ngrid), hfmax(ngrid)!, zi(ngrid)
 
 c    Traceurs :
-      integer nq 
-      REAL pqsurf(ngrid,nq)
-      real pq(ngrid,nlay,nq), pdqfi(ngrid,nlay,nq) 
-      real pdqdif(ngrid,nlay,nq) 
-      real pdqsdif(ngrid,nq) 
+      integer,intent(in) :: nq 
+      REAL,INTENT(IN) :: pqsurf(ngrid,nq)
+      real,intent(in) :: pq(ngrid,nlay,nq), pdqfi(ngrid,nlay,nq) 
+      real,intent(out) :: pdqdif(ngrid,nlay,nq) 
+      real,intent(out) :: pdqsdif(ngrid,nq) 
       
 c   local:
@@ -99,6 +106,5 @@
       EXTERNAL SSUM,SCOPY
       REAL SSUM
-      LOGICAL firstcall
-      SAVE firstcall
+      LOGICAL,SAVE :: firstcall=.true.
 
 
@@ -112,6 +118,6 @@
       
 c     For latent heat release from ground ice sublimation    
-      REAL tsrf_lw(ngridmx)
-      REAL alpha
+!      REAL tsrf_lw(ngridmx)
+!      REAL alpha
       REAL T1,T2
       SAVE T1,T2
@@ -125,5 +131,4 @@
       REAL rho(ngridmx) ! near surface air density
       REAL qsat(ngridmx)
-      DATA firstcall/.true./
 
       REAL kmixmin
@@ -179,5 +184,5 @@
          if (tracer) then
 c          Prepare Special treatment if one of the tracer is CO2 gas
-           do iq=1,nqmx
+           do iq=1,nq
              if (noms(iq).eq."co2") then
                 ico2=iq
@@ -196,7 +201,4 @@
         firstcall=.false.
       ENDIF
-
-
-
 
 
@@ -398,8 +400,7 @@
 
       pt(:,:)=ph(:,:)*ppopsk(:,:)
-      CALL yamada4(ngrid,nlay,ptimestep,g,r,pplev,pt
+      CALL yamada4(ngrid,nlay,nq,ptimestep,g,r,pplev,pt
      s   ,pzlev,pzlay,pu,pv,ph,pq,zcdv_true,pq2,zkv,zkh,zkq,ust
      s   ,9)
-
       ENDIF
 
@@ -900,3 +901,3 @@
 
       RETURN
-      END
+      END SUBROUTINE vdifc
Index: /trunk/LMDZ.MARS/libf/phymars/watercloud.F
===================================================================
--- /trunk/LMDZ.MARS/libf/phymars/watercloud.F	(revision 1035)
+++ /trunk/LMDZ.MARS/libf/phymars/watercloud.F	(revision 1036)
@@ -7,4 +7,8 @@
       USE ioipsl_getincom
       USE updaterad
+      use tracer_mod, only: nqmx, igcm_h2o_vap, igcm_h2o_ice,
+     &                      igcm_dust_mass, igcm_dust_number,
+     &                      igcm_ccn_mass, igcm_ccn_number,
+     &                      rho_dust, nuice_sed, nuice_ref
       IMPLICIT NONE
 
@@ -34,5 +38,5 @@
 #include "comcstfi.h"
 #include "callkeys.h"
-#include "tracer.h"
+!#include "tracer.h"
 #include "comgeomfi.h"
 #include "dimradmars.h"
Index: /trunk/LMDZ.MARS/libf/phymars/yamada4.F
===================================================================
--- /trunk/LMDZ.MARS/libf/phymars/yamada4.F	(revision 1035)
+++ /trunk/LMDZ.MARS/libf/phymars/yamada4.F	(revision 1036)
@@ -8,7 +8,8 @@
 !************************************************************
 !************************************************************
-      SUBROUTINE yamada4(ngrid,nlay,dt,g,rconst,plev,temp
+      SUBROUTINE yamada4(ngrid,nlay,nq,dt,g,rconst,plev,temp
      s   ,zlev,zlay,u,v,phc,pq,cd,q2,km,kn,kq,ustar
      s   ,iflag_pbl)
+      use tracer_mod, only: noms
       IMPLICIT NONE
 !.......................................................................
@@ -16,5 +17,5 @@
 #include "dimensions.h"
 #include "dimphys.h"
-#include "tracer.h"
+!#include "tracer.h"
 #include "callkeys.h"
 !.......................................................................
@@ -61,4 +62,5 @@
       INTEGER, INTENT(IN)    :: iflag_pbl,ngrid
       INTEGER, INTENT(IN)    :: nlay
+      INTEGER, INTENT(IN)    :: nq
       REAL,    INTENT(INOUT) :: q2(ngrid,nlay+1)
       REAL,    INTENT(OUT)   :: km(ngrid,nlay+1)
@@ -119,5 +121,5 @@
       SAVE A, B
       REAL teta(ngrid,nlay)
-      REAL pq(ngrid,nlay,nqmx)
+      REAL pq(ngrid,nlay,nq)
       REAL kminfact
       INTEGER i
@@ -135,5 +137,5 @@
         if (tracer) then
 !     Prepare Special treatment if one of the tracers is CO2 gas
-           do iq=1,nqmx
+           do iq=1,nq
              if (noms(iq).eq."co2") then
                 ico2=iq
@@ -603,5 +605,5 @@
 #include "dimensions.h"
 #include "dimphys.h"
-#include "tracer.h"
+!#include "tracer.h"
 #include "callkeys.h"
 !.......................................................................
@@ -684,5 +686,5 @@
 #include "dimensions.h"
 #include "dimphys.h"
-#include "tracer.h"
+!#include "tracer.h"
 #include "callkeys.h"
 !.......................................................................
Index: /trunk/LMDZ.MARS/makegcm_g95
===================================================================
--- /trunk/LMDZ.MARS/makegcm_g95	(revision 1035)
+++ /trunk/LMDZ.MARS/makegcm_g95	(revision 1036)
@@ -530,5 +530,5 @@
 # Build the appropriate 'dimensions.h' file
 cd dimension
-./makdim $ntrac $dim
+./makdim $dim
 # echo contents of dimensions.h to standard output
 cat $libf/grid/dimensions.h
@@ -556,6 +556,9 @@
 echo dimension $dimension dim $dim
 if ( $dimension == 1 ) then
-  echo pas de dynamique
-  set dyn="L_DYN= DYN= L_FILTRE= DIRMAIN=phy$physique "
+  echo "No dynamics"
+##  set dyn="L_DYN= DYN= L_FILTRE= DIRMAIN=phy$physique "
+## NB: we still need to have L_DYN=libdyn3d to reach routines and module
+## objects which are located in dyn3d
+  set dyn="L_DYN=-ldyn3d DYN= L_FILTRE= DIRMAIN=phy$physique "
 endif
 endif
Index: /trunk/LMDZ.MARS/makegcm_gfortran
===================================================================
--- /trunk/LMDZ.MARS/makegcm_gfortran	(revision 1035)
+++ /trunk/LMDZ.MARS/makegcm_gfortran	(revision 1036)
@@ -528,5 +528,5 @@
 # Build the appropriate 'dimensions.h' file
 cd dimension
-./makdim $ntrac $dim
+./makdim $dim
 # echo contents of dimensions.h to standard output
 cat $libf/grid/dimensions.h
@@ -554,6 +554,9 @@
 echo dimension $dimension dim $dim
 if ( $dimension == 1 ) then
-  echo pas de dynamique
-  set dyn="L_DYN= DYN= L_FILTRE= DIRMAIN=phy$physique "
+  echo "No dynamics"
+##  set dyn="L_DYN= DYN= L_FILTRE= DIRMAIN=phy$physique "
+## NB: we still need to have L_DYN=libdyn3d to reach routines and module
+## objects which are located in dyn3d
+  set dyn="L_DYN=-ldyn3d DYN= L_FILTRE= DIRMAIN=phy$physique "
 endif
 endif
Index: /trunk/LMDZ.MARS/makegcm_ifort
===================================================================
--- /trunk/LMDZ.MARS/makegcm_ifort	(revision 1035)
+++ /trunk/LMDZ.MARS/makegcm_ifort	(revision 1036)
@@ -184,7 +184,7 @@
 # Ehouarn 'ifort' compiler
    #NB: on gnome -O3 ==> NaNs ...
-   set optim=" -O2 -fp-model precise -ip -mkl=sequential -align all "
-   set optim90=" -O2 -fp-model precise -ip -mkl=sequential -align all "
-   set optimtru90=" -O2 -fp-model precise -ip -mkl=sequential -align all "
+   set optim="-auto -O2 -fp-model precise -ip -mkl=sequential -align all "
+   set optim90="-auto -O2 -fp-model precise -ip -mkl=sequential -align all "
+   set optimtru90="-auto -O2 -fp-model precise -ip -mkl=sequential -align all "
 #   set opt_link=" -Mfree -lpgf90 -lpgftnrtl -lpghpf -lpghpf2 -L$NCDFLIB -lnetcdf -Bstatic "
 #   set mod_loc_dir=$LIBOGCM
@@ -531,5 +531,5 @@
 # Build the appropriate 'dimensions.h' file
 cd dimension
-./makdim $ntrac $dim
+./makdim $dim
 # echo contents of dimensions.h to standard output
 cat $libf/grid/dimensions.h
@@ -557,6 +557,9 @@
 echo dimension $dimension dim $dim
 if ( $dimension == 1 ) then
-  echo pas de dynamique
-  set dyn="L_DYN= DYN= L_FILTRE= DIRMAIN=phy$physique "
+  echo "No dynamics"
+##  set dyn="L_DYN= DYN= L_FILTRE= DIRMAIN=phy$physique "
+## NB: we still need to have L_DYN=libdyn3d to reach routines and module
+## objects which are located in dyn3d
+  set dyn="L_DYN=-ldyn3d DYN= L_FILTRE= DIRMAIN=phy$physique "
 endif
 endif
Index: /trunk/LMDZ.MARS/makegcm_pgf
===================================================================
--- /trunk/LMDZ.MARS/makegcm_pgf	(revision 1035)
+++ /trunk/LMDZ.MARS/makegcm_pgf	(revision 1036)
@@ -532,5 +532,5 @@
 # Build the appropriate 'dimensions.h' file
 cd dimension
-./makdim $ntrac $dim
+./makdim $dim
 # echo contents of dimensions.h to standard output
 cat $libf/grid/dimensions.h
@@ -558,6 +558,9 @@
 echo dimension $dimension dim $dim
 if ( $dimension == 1 ) then
-  echo pas de dynamique
-  set dyn="L_DYN= DYN= L_FILTRE= DIRMAIN=phy$physique "
+  echo "No dynamics"
+##  set dyn="L_DYN= DYN= L_FILTRE= DIRMAIN=phy$physique "
+## NB: we still need to have L_DYN=libdyn3d to reach routines and module
+## objects which are located in dyn3d
+  set dyn="L_DYN=-ldyn3d DYN= L_FILTRE= DIRMAIN=phy$physique "
 endif
 endif
